#!/usr/bin/php4
<?php
	// pppd.log feldolgoz script
	// rta: palacsint <palacsint AT palacsint.hu>
	// http://www.palacsint.hu/
	// 2004. augusztus
	// GNU/GPL
	
	// tesztelve/fejlesztve: 
	//	debian 3.0
	//	pppd version 2.4.1

	// idblyeg hossza a log elejn
	define("TS_LEN", 15);
	
/* bejv adatok valami ilyesmihez hasonltanak
Aug 20 21:44:11 jumper pppd[7565]: pppd 2.4.1 started by root, uid 0
Aug 20 21:44:42 jumper pppd[7565]: Serial connection established.
Aug 20 21:44:42 jumper pppd[7565]: Using interface ppp0
Aug 20 21:44:42 jumper pppd[7565]: Connect: ppp0 <--> /dev/ttyS0
Aug 20 21:44:44 jumper pppd[7565]: Couldn't set pass-filter in kernel: Invalid argument
Aug 20 21:44:44 jumper pppd[7565]: Cannot determine ethernet address for proxy ARP
Aug 20 21:44:44 jumper pppd[7565]: local  IP address 62.112.205.85
Aug 20 21:44:44 jumper pppd[7565]: remote IP address 62.112.195.226
*/	

	function gettime_from_line($l) {
		global $months;

		// FIXME: ezt itt jra lehetne rni
		// a logfjlban a dtum a $max. szkz utn vget r
		$max = 4;
		$l = substr($l, 0, TS_LEN);

		$la = explode(" ", $l, $max);
		if (!isset($months[$la[0]])) {
			debug_echo("month: {$la[0]}");
			// ha nincs a logban megadott hnap, akkor vmi gz van
			return false;
		} 

		// dtum sszelltsa az strtotime() szmra
		$sts = substr($l, 0, 7) . strftime("%Y") . substr($l, 6);
		debug_echo("sts: $sts");
		$ts = strtotime($sts);
		
		if ($ts === -1) {
			debug_echo("gettime_from_line = -1");
			$ts = false;
		}
		//debug_echo ("--> $sts ($ts) " . strftime("%Y-%m-%d %H:%M:%S", $ts));
		return $ts;
	}
	
	function update_bytes($line, $ts) {
		$la = explode(" ", substr($line, TS_LEN + 1));
		//$la = explode(" ", $line);
		$rb = $la[6];
		$sb = $la[3];
		
		/* +-5 sec ha esetleg nem stimmelne a log ideje valami miatt */
		$ts_text_s = strftime("%Y-%m-%d %H:%M:%S", $ts - 5);
		$ts_text_e = strftime("%Y-%m-%d %H:%M:%S", $ts + 5);
		
		
		$sql_u = "UPDATE connects SET recv_bytes = '$rb', send_bytes = '$sb'
				WHERE endtime > '$ts_text_s' AND endtime < '$ts_text_e'";
		if (mysql_query($sql_u) === false) {
			printf("mysql_error(): " . mysql_error());
		} else {
			$ts_text = strftime("%Y-%m-%d %H:%M:%S", $ts);
			debug_echo("bytes update $ts_text OK");
		}
	}
	
	/* benne van-e mr az adatbzisban a megadott endtime rekord? */
	function is_idb($et) {
		$sql_q = "SELECT * FROM connects WHERE endtime = '$et'";
		$sql_res = mysql_query($sql_q);
		if ($sql_res && (mysql_num_rows($sql_res) > 0)) 
			return true;
		else
			return false;
	}

	/* berakja sql-be az adott kapcsolatot */
	function putsql($starttime, $endtime) {
		// FIXME: bontsa tbb rszre, ha nem egy nap
		// csak kt napos kapcsolatokat tud kezelni!
		
/*
Aug 20 20:05:51 jumper pppd[7426]: Sent 113871 bytes, received 1845889 bytes.
*/		
		$diff = $endtime - $starttime;

		debug_echo("get_day1: " . getday($starttime));
		debug_echo("get_day2: " . getday($endtime));
		
		
		if (getday($starttime) != getday($endtime)) {
			if (getday($starttime) != getday($endtime - 24 * 3600)) {
				die("no such feature (putsql())\n");
			}
			
			$st = strftime("%Y-%m-%d %H:%M:%S", $starttime);
			$et = strftime("%Y-%m-%d 23:59:59", $starttime);
			if (!is_idb($et)) {
				$sql_i = "INSERT INTO connects (starttime, endtime, recv_bytes, send_bytes) 
					VALUES ('$st', '$et', '0', '0')";
				//debug_echo($sql_i);
				debug_echo("conn: $st => $et");
				mysql_query($sql_i) or printf("mysql_error(): " . mysql_error());
			} else {
				debug_echo("mar volt.");	
			}
			$starttime = strtotime($et) + 1;
			$st = strftime("%Y-%m-%d 00:00:00", $endtime);
			
		} else {
			$st = strftime("%Y-%m-%d %H:%M:%S", $starttime);
		}
		
		$et = strftime("%Y-%m-%d %H:%M:%S", $endtime);		
		debug_echo("conn: $st => $et");
		if (!is_idb($et)) {
			$sql_i = "INSERT INTO connects (starttime, endtime, recv_bytes, send_bytes) 
				VALUES ('$st', '$et', '0', '0')";
			//debug_echo($sql_i);
			mysql_query($sql_i) or printf("mysql_error(): " . mysql_error());
		} else {
			debug_echo("mar volt.");	
		}
		
	}


	require_once(dirname(__FILE__) . "/init.inc.php");
	
	/* hogy biztosan ki legyen rva a log, mire lefut a script */
	sleep(5);
	
	
	$stdin = @fopen(INPUT_FILE, 'r');
	//$stdin = fopen("/var/log/all.log.0", 'r');
	if ($stdin === false) {
		die(sprintf("A naplfjl (%s) megnyitsa sikertelen!\n", INPUT_FILE));
	}
	$seconds = $starttime = $endtime = 0;
	$t_starttime = $t_endtime = 0;

	while (!feof ($stdin)) {
		$line = fgets($stdin, 4096);
		/* az elejrl levgjuk a dtumot majd darabols */
		$la = explode(" ", substr($line, TS_LEN + 1));

		/* ha a pppd-tl jn a log, csak akkor csinlunk brmit is */
		if (isset($la[1]) && (substr($la[1], 0, 5) == "pppd[")) {
			
			/* ez itt egy kapcsolat vge */
			if (isset($la[4]) && (strpos($line, "Connect time") > 0)) {
				$endtime = gettime_from_line($line);
				//FIXME: ha 0.4 akkor 0 lesz a $seconds :(
				/* ha 0.4, valamirt nem konvertlja floatra, ilyenkor
				   legyen 60 sec s ksz */
				if (substr($la[4], 0, 2) == '0.') {
					$seconds = 60;
				} else {
					$seconds = $la[4] * 60;
				}
				$starttime = $endtime - $seconds;
				putsql($starttime, $endtime);

			/* vett-kldtt bjtok rzkelse*/
			} elseif (isset($la[5]) && ($la[2] == "Sent") &&
			($la[5] == "received")) {
				update_bytes($line, gettime_from_line($line));
			}
			//echo $line ;	
		}
		

	} // while (!feof($stdin))
	
	fclose($stdin);

?>