<?php
	// pppd-timeinfo init script
	// rta: palacsint <palacsint AT palacsint.hu>
	// 2004. augusztus
	// GNU/GPL
	
	$mphp_self = basename($_SERVER["PHP_SELF"]);
	if (($mphp_self != "show.php") && ($mphp_self != "input.php") && ($mphp_self != '')) {
		die();
	}
	
	setlocale (LC_ALL, 'hu_HU');

	require_once(dirname(__FILE__) . "/config.inc.php");

	if (defined("DEBUG")) {
		error_reporting(E_ALL);
	} else {
		error_reporting(0);
	}
	
	$napok[1] = "Htf";
	$napok[2] = "Kedd";
	$napok[3] = "Szerda";
	$napok[4] = "Cstrtk";
	$napok[5] = "Pntek";
	$napok[6] = "Szombat";
	$napok[7] = $napok[0] = "Vasrnap";

	// ellenrizve
	$months["Jan"] = "01";
	$months["Feb"] = "02";
	$months["Mar"] = "03";
	$months["Apr"] = "04";
	$months["May"] = "05";
	$months["Jun"] = "06";
	$months["Jul"] = "07";
	$months["Aug"] = "08";
	$months["Sep"] = "09";
	$months["Oct"] = "10";
	$months["Nov"] = "11";
	$months["Dec"] = "12";

	define("ERR_SQL", "sql hiba");
	define("ERR_CONFIG", "konfigurcis hiba");
		
	/* paranoia rulz */
	if (!is_numeric($M_START) || $M_START > 31 || $M_START < 1) {
		debug_echo("A M_START rtke hibs!");
		die(ERR_CONFIG);	
	}
		

	$database = mysql_connect(DBHOST, DBUSER, DBPASS);
	if ($database === false) {
		debug_echo(mysql_error());
		die(ERR_SQL);	
	}
	if (mysql_select_db(DBNAME, $database) === false) {
		debug_echo(mysql_error());
		die(ERR_SQL);	
	}

	function debug_echo($s) {
		if (defined("DEBUG"))
			echo $s . "\n";	
	}

	
	/* az adott nap levgsa, csak az jfltl eltelt msodpercek meghagysa */
	function daysec($ts) {
		$t = strtotime($ts);
		$ds = (int)strftime("%H", $t) * 3600;
		$ds += (int)strftime("%M", $t) * 60;
		$ds += (int)strftime("%S", $t);
		return $ds;
	}
	
	/* a nap dtumval tr vissza */
	function getday($ts) {
		// ez valamirt nem mkdik
		//$t = strtotime($ts);
		//return $ts - daysec($ts);
		return strftime("%Y-%m-%d", $ts);
	}

	function dec_mdate($d) {
		$y = (int)substr($d, 0, 4);
		$m = (int)substr($d, 4, 2);
		if ($m == 1) {
			$y--;
			$m = 12;	
		} else {
			$m--;	
		}
		
		return sprintf("%4d%02d", $y, $m);
	}

	function inc_mdate($d) {
		$y = (int)substr($d, 0, 4);
		$m = (int)substr($d, 4, 2);
		if ($m == 12) {
			$y++;
			$m = 1;	
		} else {
			$m++;	
		}
		return sprintf("%4d%02d", $y, $m);
	}

	/* a legels s a legutols utni hnapban lehetsges 
	   kapcsolat dtumval tr vissza */
	function get_firstlast_connect() {
		global $M_START;
		
		$sql_q = "SELECT min(starttime) AS first, max(endtime) AS last FROM connects";
		$sql_res = mysql_query($sql_q);
		if ($sql_res === false) {
			debug_echo(mysql_error());
			die(ERR_SQL);			
		}
		$arr = mysql_fetch_assoc($sql_res);
		if ($arr === false) {
			debug_echo(mysql_error());
			die(ERR_SQL);	
		}
		$first = $arr["first"];
		$last = $arr["last"];
		
		$f_ts = strtotime($first);
		$l_ts = strtotime($last);
		
	
		/* ha az els dtum napja kisebb mint $M_START, 
		   akkor mg kell egy hnap a listba */
		$ret_first = strftime("%Y%m", $f_ts);
		if ((int)strftime("%d", $f_ts) < $M_START) {
			$ret_first = dec_mdate($ret_first);
		}

		/* ha az utols dtum napja kisebb mint $M_START, 
		   akkor nem kell az utols hnap a listhoz */
		$ret_last = strftime("%Y%m", $l_ts);
		if ((int)strftime("%d", $l_ts) < $M_START) {
			$ret_last = dec_mdate($ret_last);
		}
		
		return array($ret_first, inc_mdate($ret_last));
	}


?>