<?php
	// pppd_timeinfo megjelenito script
	// rta: palacsint <palacsint AT palacsint.hu>
	// http://www.palacsint.hu/
	// 2004
	// GNU/GPL
	list($start_sec, $start_ssec) = explode(" ", microtime());
	$start_time = $start_sec + $start_ssec;


	require_once(dirname(__FILE__) . "/init.inc.php");
?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>

<head>
	<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-2">
	<META HTTP-EQUIV="EXPIRES" CONTENT="0">
	<META NAME="RESOURCE-TYPE" CONTENT="DOCUMENT">
	<META NAME="DISTRIBUTION" CONTENT="GLOBAL">
	<META NAME="AUTHOR" CONTENT="palacsint">
	<META NAME="COPYRIGHT" CONTENT="Copyright (c) 2003-2004 palacsint">

	<META NAME="KEYWORDS" CONTENT="">
	<META NAME="DESCRIPTION" CONTENT="pppd timeinfo">
	<META NAME="ROBOTS" CONTENT="NOINDEX, NOFOLLOW">
	<META NAME="RATING" CONTENT="GENERAL">
	<META NAME="GENERATOR" CONTENT="notepad ofkoz">
	<meta name="language" content="hu">
	<meta http-equiv="content-language" content="hu">

	<title>pppd_timeinfo</title>
</head>

<body id="pppd_timeinfo">



<?php

	/* prefixumokkal ltja el a megadott bjtszmot */
	function af($b) {
		return sprintf("%.2f MiB", $b / 1024 / 1024);
	}


	// kiirja napokban, rkban, percekben a megadott msodpercet
	function wh($s) {
		$ret = '';
		
		/*$days = floor($s / 24 / 3600);
		if ($days >= 1) {
			$ret .= sprintf("%dd", $days);
			$s -= $days * 3600 * 24;
		}*/
		
		$hours = floor($s / 3600);
		if ($hours >= 1) {
			$ret .= sprintf(" %dh", $hours);
			$s -= $hours * 3600;
		}
		
		$mins = floor($s / 60);
		if ($mins >= 1) {
			$ret .= sprintf(" %dm", $mins);
		}
		return $ret;
		return sprintf("%dh %dm", floor($s / 3600), floor(($s % 3600) / 60));
	}

	/* a megjelentsnl hasznlt msodpercek helyett esetleg vmi mst
	 * rjon ki... */
	function pt($s) {
		
		$back = '&nbsp;';
		if ($s > 3600) {
			$back .= sprintf("%dh ", floor($s / 3600));	
		}
		if ((($s % 3600) / 60) != 0) {
			$back .= sprintf("%dm", (($s % 3600) / 60));
		}
		
		if (($s % 60) != 0) {
			$back .= sprintf(" %ds", $s % 60);
		}
		
		//return sprintf("%dh %dm", floor($s / 3600), floor(($s % 3600) / 60));
		return $back;	
	}


	/* eldnti, hogy munkanap-e a megadott dtum */
	/* ettl fgg a szmlzs */
	function munkanap($ts) {
		global $munkanapok, $szabadnapok;
		
		$t = strtotime($ts);
		$date = strftime("%Y-%m-%d", $t);
		
		if (isset($munkanapok[$date]))
			return true;
		if (isset($szabadnapok[$date]))
			return false;
		
		$nsz = date("w", $t);
		if ($nsz > 0 && $nsz < 6)
			return true;
			
		return false;
		
	}
	

	/* sor httrsznnek blltsa */	
	function rowbgcolor($dt) {
		if (munkanap($dt)) {
			//debug_echo("munkanap: $dt");
			return "#ffffff";	
		} else {
			//debug_echo("szabadnap: $dt");
			return "#999999";	
		}
	}



	function calc_diff($a) {
		return (strtotime($a["endtime"]) - strtotime($a["starttime"]));	
	}
	
	function calc_nappali($a) {
		
		/* ha nem munkanap van, akkor nincs ilyen */
		if (!munkanap($a["starttime"])) {
			return 0;	
		} else {
			$st = daysec($a["starttime"]);
			$et = daysec($a["endtime"]);
		
			$st = max($st, 7 * 3600);
			$et = min($et, 16 * 3600);
		
			$diff = $et - $st;
			$diff = max($diff, 0);
		
			return $diff;
		}
	}
	
	function calc_kedv($a) {
		$st = daysec($a["starttime"]);
		$et = daysec($a["endtime"]);

		/* ha munkanap van 16:00-kor, egybknt 7:00-kor
		   kezdodik a kedvezmenyes idoszak */
		if (munkanap($a["starttime"])) {
			$s_kedv = 16 * 3600;
		} else {
			$s_kedv = 7 * 3600;
		}
		$st = max($st, $s_kedv);
		$et = min($et, 24 * 3600);
		
		$diff = $et - $st;
		$diff = max($diff, 0);
		
		return $diff;
	}
	
	/* 00:00-tl 07:00-ig jszakai percdj van, ezt szmolja ki msodpercekben */
	function calc_ejszakai($a) {
		$st = daysec($a["starttime"]);
		$et = daysec($a["endtime"]);
		
		$st = max($st, 0);
		$et = min($et, 7*3600);
		
		$diff = $et - $st;
		$diff = max($diff, 0);
		
		return $diff;
	}
	
	/* megfelel formtumra hozza az YYYYMM formtumu hnapokat a kiirshoz */
	function months_format($d) {
		return sprintf("%s. %s.", 
			substr($d, 0, 4), 
			strftime("%b", mktime(0, 0, 0, (int)substr($d, 4, 2), 1, 2004)));
		//return $d;		
	}	

	/* visszatr a hnapok listjval, linkelve */
	function show_months($param_t = '') {
		$ret = '';

		list ($first, $last) = get_firstlast_connect();
		$d = $first;
		while ($d != $last) {
			if ($d != $first) {
				$ret .= " - ";
			}
			$ret .= sprintf('<a href="%s?t=%s&amp;m=%s">%s</a>',
					$_SERVER["PHP_SELF"], $param_t, $d, months_format($d));
			$d = inc_mdate($d);
		};
		return $ret;
	}



	$default_m = false;
	/* az "m" -tl fgg, hogy melyik hnapot jelentjk meg */
	/* m = "YYYYMM", 6 char, YYYY az v, MM a hnap */
	if (!isset($_GET["m"]) || !is_numeric($_GET["m"])) {
		$default_m = true;
	} else {
		/* az m paramter helyessgnek ellenrzse */
		/* ha nem j ($default_m == true), akkor az aktulis hnapot jelentjk meg */
		$m = $_GET["m"];
		if (strlen($m) != 6) {
			$default_m = true;	
		}
		if ((int)substr($m, 0, 4) < 2004) {
			$defaul_m = true;	
		}
		/* a hnap 1-12 lehet */
		if ((int)substr($m, 4, 2) < 1) {
			$default_m = true;	
		}
		if ((int)substr($m, 4, 2) > 12) {
			$default_m = true;	
		}
	}

	if ($default_m === false) {
		$g_year = substr($m, 0, 4);
		$g_month = substr($m, 4, 2);
		$m_start = "$g_year-$g_month-$M_START 00:00:00";
		$m_start_ts = strtotime($m_start);
		/* ha valami mgsem stimmelne, br ez valszeg csak paranoia */
		if ($m_start_ts === -1) {
			$default_m = true;	
			debug_echo(__FILE__ . ":" . __LINE__);
		} 
	}
	if ($default_m === false) {
		$m_end = strftime("%Y-%m-$M_START 00:00:00", $m_start_ts + 24 * 3600 * 31);
		$m_end_ts = strtotime($m_end);
		/* ez szintn csak paranoia asszem */
		if ($m_end_ts === -1) {
			$default_m = true;
			debug_echo(__FILE__ . ":" . __LINE__);
		}
	}
	if ($default_m === false) {
		$month_param = $m;
	}



	if ($default_m) {
		debug_echo("default_month");
		$mtime = mktime();
		if ((int)strftime("%d", $mtime) < $M_START) {
			$mtime -= 24 * 3600 * ($M_START + 1);
		}
		
		$m_start = strftime("%Y-%m-$M_START 00:00:00", $mtime);
		$m_end = strftime("%Y-%m-$M_START 00:00:00", $mtime + 24 * 3600 * 31);
		$m_start_ts = strtotime($m_start);
		$m_end_ts = strtotime($m_end);
		$month_param = strftime("%Y%m", $mtime);
	}

	if (isset($_GET["t"])) {
		$t = $_GET["t"];	
	} else {
		$t = 'daily';	
	}


	if ($t == 'daily') {
		require_once(dirname(__FILE__) . "/inc_show-daily.php");	
	} else {
		require_once(dirname(__FILE__) . "/inc_showm.php");
	}

	list($end_sec, $end_ssec) = explode(" ", microtime());
	$end_time = $end_sec + $end_ssec;
	$runtime = sprintf("%.5f", $end_time - $start_time);

?>
<small>runtime: <?= $runtime ?> sec</small>
</body>
</html>